"""
This module contains the caching system.
"""

from dogpile.cache import exception, make_region
from dogpile.cache.util import kwarg_function_key_generator

cache = make_region(function_key_generator=kwarg_function_key_generator)


def set_cache(conf: dict):
    # We use memory_pickle instead of memory to catch attempts at caching
    # non-serializable values.
    conf.setdefault("backend", "dogpile.cache.memory_pickle")
    try:
        cache.configure(**conf)
    except exception.RegionAlreadyConfigured:
        pass
